globals [opinion-self opinion-partner resource-self resource-partner visit-range sum-r sum-d sum-o sum-v sum-rd sum-ro sum-rv R-rd R-ro R-rv ]
turtles-own [resource opinion density visit-density diversity back-x back-y on-mix cov-rd cov-ro cov-rv dev-r dev-d dev-o dev-v]
patches-own [num-turtles mean-resource dis-center]
to setup
  ca
  crt number-of-turtles [
    setxy 0 0
    right random 360 fd random-normal 0 initial-distribution
    set resource 1 + random-float 9
    set shape "face neutral"
    set color resource
    set density (count turtles-on neighbors + count turtles-here) / 9
    set opinion density
    ifelse any? other turtles in-radius 1
    [set diversity variance [resource] of turtles in-radius 1]
    [set diversity 0]
  ]
 reset-ticks
 ask patches [set pcolor white]
 ask patches with [pxcor = max-pxcor or pxcor = min-pxcor or pycor = max-pycor or pycor = min-pycor] [set pcolor black]
 ;;data-record
end
to go
  ask turtles [
    set density (count turtles-on neighbors + count turtles-here) / 9
    ifelse any? other turtles in-radius 1
     [set diversity variance [resource] of turtles in-radius 1]
     [set diversity 0]
    ;; eviction
    if resource < density * cost [right random 360 fd eviction-range set shape "face sad" ]
    set shape "face happy"
    ;; visit and migration
    set back-x xcor set back-y ycor
    set density (count turtles-on neighbors + count turtles-here) / 9
    if mobility-yes?
    [
      ifelse mobility-free?
      [setxy random-xcor random-ycor]
      [
        if resource > density * cost
        [set visit-range (resource - density * cost) * (2 ^ mobility) right random 360 fd random visit-range]
      ]
      set visit-density (count turtles-on neighbors + count turtles-here) / 9
      ifelse abs(opinion - density) > abs(opinion - visit-density)
      [set density visit-density]
      [setxy back-x back-y]
    ]
    ;; interaction with other turtles
    if any? turtles-on neighbors
    [
      let partner one-of turtles-on neighbors
      set opinion-self opinion
      set opinion-partner [opinion] of partner
      set opinion (1 - opinion-change-partner) * opinion + opinion-change-partner * opinion-partner
      ask partner [set opinion (1 - opinion-change-partner) * opinion + opinion-change-partner * opinion-self]
    ]
    ;; interaction with environments
    set density (count turtles-on neighbors + count turtles-here) / 9
    set opinion (1 - opinion-change-environment) * opinion + opinion-change-environment * density
    ;; mutation
    if random-float 1 < mutation
     [
        set opinion opinion + random-float 2 - 1
        if opinion < 0.1 [set opinion 0.1]
     ]
  ]
  tick
  if ticks mod 10 = 0 [calcurate-r   ;;data-update
  ]
  if ticks = 1000 [datafinish
  stop]
end
to calcurate-r
  ask turtles [
      set cov-rd (resource - mean [resource] of turtles) * (density - mean [density] of turtles)
      set cov-ro (resource - mean [resource] of turtles) * (opinion - mean [opinion] of turtles)
      set cov-rv (resource - mean [resource] of turtles) * (diversity - mean [diversity] of turtles)
      set dev-r (resource - mean [resource] of turtles) ^ 2
      set dev-d (density - mean [density] of turtles) ^ 2
      set dev-o (opinion - mean [opinion] of turtles) ^ 2
      set dev-v (diversity - mean [diversity] of turtles) ^ 2
    ]
  set sum-r sqrt (sum [dev-r] of turtles)
  set sum-d sqrt (sum [dev-d] of turtles)
  set sum-o sqrt (sum [dev-o] of turtles)
  set sum-v sqrt (sum [dev-v] of turtles)
  set sum-rd sum [cov-rd] of turtles
  set sum-ro sum [cov-ro] of turtles
  set sum-rv sum [cov-rv] of turtles
  if (sum-r * sum-d != 0)[set R-rd sum-rd / sum-r / sum-d]
  if (sum-r * sum-o != 0)[set R-ro sum-ro / sum-r / sum-o]
  if (sum-r * sum-v != 0)[set R-rv sum-rv / sum-r / sum-v]
end
to data-record
  if (file-exists? "opinion.csv")[file-delete "opinion.csv"]
  file-open "opinion.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word "agent" who ",")]] file-print ""
  file-close
  if (file-exists? "density.csv")[file-delete "density.csv"]
  file-open "density.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word "agent" who ",")]] file-print ""
  file-close
  if (file-exists? "diversity.csv")[file-delete "diversity.csv"]
  file-open "diversity.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word "agent" who ",")]] file-print ""
  file-close
end
to data-update
  file-open "opinion.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word opinion ",")]] file-print ""
  file-close
  file-open "density.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word density ",")]] file-print ""
  file-close
  file-open "diversity.csv"
  file-type (word ticks ",")
  foreach sort turtles [a-turtle -> ask a-turtle [file-type (word diversity ",")]] file-print ""
  file-close
end
to datafinish
 file-open "patch.csv"
  file-print("px,py,num-turtles,mean-resource,dis-center")
  foreach sort patches  [a-patch -> ask a-patch [file-type (word pxcor ",") file-type (word pycor ",") file-type (word num-turtles ",") file-type(word mean-resource ",")file-print(word dis-center)]]
  file-close
  file-open "agent_data.csv"
  file-print("id,resource,opinion,density,diversity")
  ask turtles [file-type (word who ",")file-type (word resource ",")file-type (word opinion ",")file-type (word density ",")file-print (word diversity ",")]
  file-close
end
@#$#@#$#@
GRAPHICS-WINDOW
622
10
940
329
-1
-1
10.0
1
10
1
1
1
0
1
1
1
-15
15
-15
15
0
0
1
ticks
30.0

SLIDER
43
10
215
43
number-of-turtles
number-of-turtles
0
900
400.0
1
1
NIL
HORIZONTAL

SLIDER
38
123
210
156
cost
cost
0
5
1.0
0.05
1
NIL
HORIZONTAL

BUTTON
629
354
695
387
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
704
353
767
386
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
227
10
400
43
opinion-change-partner
opinion-change-partner
0
0.01
0.01
0.001
1
NIL
HORIZONTAL

SLIDER
42
46
214
79
initial-distribution
initial-distribution
0
max-pxcor
2.0
0.1
1
NIL
HORIZONTAL

SLIDER
41
84
213
117
eviction-range
eviction-range
0
10
1.0
1
1
NIL
HORIZONTAL

PLOT
419
15
610
205
histogram
NIL
NIL
0.0
40.0
0.0
300.0
true
false
"" ""
PENS
"density" 1.0 1 -13345367 true "" "histogram [density] of turtles"
"diversity" 1.0 1 -1184463 true "" "histogram [diversity] of turtles"
"opinion" 1.0 1 -2674135 true "" "histogram [opinion] of turtles"

SLIDER
228
166
400
199
mobility
mobility
-10
10
-1.0
1
1
NIL
HORIZONTAL

SLIDER
39
165
211
198
mutation
mutation
0
0.01
0.001
0.001
1
NIL
HORIZONTAL

PLOT
353
211
612
385
Pearson's correlation coefficient
ticks
value
0.0
1000.0
-1.0
1.0
true
false
"" ""
PENS
"R-ro" 1.0 0 -2674135 true "" "plot R-ro"
"R-rd" 1.0 0 -13345367 true "" "plot R-rd"
"R-rv" 1.0 0 -1184463 true "" "plot R-rv"

PLOT
44
211
315
386
mean values
ticks
NIL
0.0
1000.0
0.0
10.0
true
false
"" ""
PENS
"opinion" 1.0 0 -2674135 true "" "plot mean [opinion] of turtles"
"density" 1.0 0 -13345367 true "" "plot mean [density] of turtles"
"diversity" 1.0 0 -1184463 true "" "plot mean [diversity] of turtles"

SLIDER
228
48
401
81
opinion-change-environment
opinion-change-environment
0
0.01
0.0
0.001
1
NIL
HORIZONTAL

SWITCH
230
87
364
120
mobility-yes?
mobility-yes?
0
1
-1000

SWITCH
229
125
367
158
mobility-free?
mobility-free?
1
1
-1000

@#$#@#$#@
## WHAT IS IT?

This project models migration of agents. Every agent has a preferred density, "opinion", and tries to migrate to a location where a density close to their opinions. However, the range of densities to look for is limited for agents. The more resources,  and the higher the mobility, an agent can explore the wider range. Agents with more resources are marked in whiter color. Manipulating the mobility, we reveal what kind of distribution of agents is created.

## HOW IT WORKS

[Initialization]
Click the SETUP button to initialize. The number of agents can be manipulated by number-of-turtles. The location of the agents is given by a normal distribution centered at the origin with initial-distribution as the standard deviation value.

[Eviction]
If the density an agent experiences in its patch multiplied by cost is higher than the amount of resources the agent has, the agent will move to a random location within evicxtion-range distance. This is considered an eviction.

[Migration]
Agent will visit any patch that is within the range from the patch it is currently. The range is the value of resource minus the density cost multiplied by mobility. It compares the density of the patch it is in with the density of the patch it has visited, and chooses the patch that is closer to its opinion and decides to migrate or stay.

[Opinion change with partner]
The agent randomly selects one other agent in the current and nearby patches, each of which changes its opinion by the minute value opinion-change-partner.

[opinion-change with environment].
The agent calculates the actual density of the patch it is in and the surrounding patches, and changes its opinion in the direction of that density by the minute value opinion-change-environment. 

[Mutation].
The agent changes its opinion by a probability of mutation, within a range of ±1. 


## HOW TO USE IT

Click on the SETUP button to configure the agent; click GO to start the simulation. If an agent does not have enough resources, it is evicted by eviction-range. 
The "cost" slider controls the density cost. (In the paper the value is 1)
The "mutation" slider controls the probability of mutation.  (In the paper the value is 0.001)
The "opinion-change-partner" slider controls the change ratio of opinion with partner.  (In the paper the value is δ)
The "opinion-change-environment" slider controls the change ratio of opinion with the density agents experience.  (In the paper the value is ε)

The main object of this simulation is mobility.
The "mobility-yes" button controls whether agents can migrate by their will.
The "mobility-free" button controls whether agents can select any patch irre4spective of their resources, or mobility = ∞
The "mobility" slider controls the value of mobility by the power of 2. For instance the slider is 0, mobility is 2 ^ 0 = 1.

## THINGS TO NOTICE

When SETUP is executed, all agents are distributed around the central patch. However, due to high density, agents with few resources, i.e., agents of black color, are expelled to the periphery. Therefore, there should be blank areas near the center patch. How the blank spaces are filled in after depends on the value of the parameter: 

If mobility is 0 small, only agents with many resources can migrate freely, so there should be more spatial segregation by the resource content of the agents. 

As mobility increases, more agents can migrate by their will. As a resuly the blank areas will fileed also by agents with few resources. Not only density but also diversity increases.

As mobility increases further, some agents will migrate to the edges of the patch. As a result, the spatial segregation of agents will increase, as agents with less resources will also migrate that way.

Check not only the spatial distribution of agents, but also the histograms, the mean value, and Pearson correlation coefficient  of density (red), opinion (blue), and diversity (yellow) along time.


## THINGS TO TRY

Try changing the value of mobility. How does the overall agent distribution change?

Try changing the values of opinion-change-partner and opinion-change-environment. How does the overall distribution of agents change?

How does the overall agent distribution change when you change other variables, such as number-of-turtles and cost?

## EXTENDING THE MODEL

## NETLOGO FEATURES

## RELATED MODELS

## CREDITS AND REFERENCES
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.2.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment1" repetitions="100" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="1000"/>
    <metric>mean [density] of turtles</metric>
    <metric>mean [opinion] of turtles</metric>
    <metric>mean [diversity] of turtles</metric>
    <metric>mean [R-rd] of turtles</metric>
    <metric>mean [R-ro] of turtles</metric>
    <metric>mean [R-rv] of turtles</metric>
    <enumeratedValueSet variable="mobility-yes?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mobility-free?">
      <value value="false"/>
    </enumeratedValueSet>
    <steppedValueSet variable="mobility" first="-1" step="1" last="6"/>
  </experiment>
  <experiment name="experiment2" repetitions="100" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="1000"/>
    <metric>mean [density] of turtles</metric>
    <metric>mean [opinion] of turtles</metric>
    <metric>mean [diversity] of turtles</metric>
    <metric>mean [R-pd] of turtles</metric>
    <metric>mean [R-po] of turtles</metric>
    <metric>mean [R-pv] of turtles</metric>
    <metric>mean [R-do] of turtles</metric>
    <metric>mean [R-dv] of turtles</metric>
    <metric>mean [R-ov] of turtles</metric>
    <enumeratedValueSet variable="mobility-yes?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mobility-free?">
      <value value="true"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment3" repetitions="100" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="1000"/>
    <metric>mean [density] of turtles</metric>
    <metric>mean [opinion] of turtles</metric>
    <metric>mean [diversity] of turtles</metric>
    <metric>mean [R-pd] of turtles</metric>
    <metric>mean [R-po] of turtles</metric>
    <metric>mean [R-pv] of turtles</metric>
    <metric>mean [R-do] of turtles</metric>
    <metric>mean [R-dv] of turtles</metric>
    <metric>mean [R-ov] of turtles</metric>
    <enumeratedValueSet variable="mobility-yes?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
